<template>
    <div id="login">
        <div id="form">
            <p class="goHome" @click="this.$router.push('/')">Go back Home</p>
            <h1>Information de connection</h1>
            <form @submit.prevent="login">
                <label for="email">Email</label>
                <input type="email" id="email" placeholder="Entrer votre Email ici." v-model="mail">
                <label for="password">Mot de passe</label>
                <input type="password" id="password" placeholder="Mot de passe" v-model="password">
                <button>Login</button>
            </form>
            <p>Ou créer un compte: <a @click="this.$router.push('/register')">S'enregistrer</a></p>
        </div>
    </div>
</template>
<script>
import { createToast } from "mosha-vue-toastify";
import VueJwtDecode from 'vue-jwt-decode';

export default {
    name: 'login',
    data() {
        return {
            mail: new URLSearchParams(window.location.search).get("email") || null,
            password: null,
        }
    },
    components: {
        
    },
    methods: {
        login() {
            if (this.mail && this.password) {
                fetch('http://localhost:3000/api/login', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                        'Access-Control-Allow-Origin': '*'
                    },
                    body: JSON.stringify({
                        mail: this.mail,
                        password: this.password
                    })
                })
                .then(response => response.json())
                .then(r => {
                    if(r.status === 200) {
                        r = r.data;
                        let userData = VueJwtDecode.decode(r.token);
                        this.$store.commit('setUsername', userData.username);
                        this.$store.commit('setProfilePicture', userData.profilePicture);
                        this.$store.commit('setMail', userData.sub);
                        this.toast(`Welcome ${userData.username}`, 'success');
                        localStorage.setItem("token", r.token);
                        this.getUserData(r.token);
                        this.$router.push(`/`);
                    } else {
                        this.toast("Something went wrong", 'danger');
                    }
                })
                .catch(err => {
                    console.log(err);
                    this.toast("Something went wrong", 'danger');
                });
            }else {
                this.toast("Please fill all the fields.", "danger");
            }
        },
        async getUserData(token) {
            if (localStorage.getItem("token")) {
                let userData = await VueJwtDecode.decode(token);
                await this.$store.commit("setUsername", userData.username);
                await this.$store.commit("setProfilePicture", userData.profilePicture);
                await this.$store.commit("setMail", userData.sub);
                fetch(`http://localhost:3000/api/userData`,
                  {
                    method: 'POST',
                    headers: {
                      'Content-Type': 'application/json',
                      'Access-Control-Allow-Origin': '*',
                      'Authorization': `Bearer ${localStorage.getItem('token')}`
                    },
                    body: JSON.stringify({
                      mail: userData.sub
                    })
                  })
                  .then(response => response.json())
                  .then(data => {
                        this.$store.commit('getUserData', data.data);
                        let date = data.data.dateCreate.split("-");
                        let datecreate = `${date[2]}/${date[1]}/${date[0]}`;
                        this.$store.commit('setDateCreate', datecreate);
                  })
                  .catch(err => {
                    if(err) {
                        console.log(err);
                        this.toast(err, 'danger');
                    }
                  })
            }
        }
    },
    setup() {
    const toast = (message, type) => {
      createToast(message, {
        position: "top-right",
        timeout: 5000,
        type: type,
        showIcon: true,
      });
    };
    return { toast };
  },
}
</script>
<style scoped>
#login {
    height: 100vh;
    background-image: url("../assets/img/bg-login.jpg");
    background-size: cover;
    background-position: right;
    display: flex;
    justify-content: flex-end;
}
#login #form
{
    height: 100%;
    width: 30%;
    display: flex;
    flex-direction: column;
    justify-content: flex-start;
    align-items: center;
    background: #ffffff;
}
#login #form > form
{
    margin-top: 5rem;
    width: 70%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: flex-start;
}
#login #form h1
{
    margin-top: 5rem;
    font-size: 2.5rem;
    color: #000000;
    text-shadow: none;
    text-align: center;
}
#login #form > form > label
{
    font-size: 1.5em;
    font-weight: bold;
    color: #000000;
    text-shadow: none;
    margin-top: 1rem;
}
#login #form > form > input
{
    width: 100%;
    height: 3rem;
    border: none;
    border-bottom: 2px solid #000000;
    margin-bottom: 2rem;
    font-size: 1.5rem;
}
#login #form > form > input:focus
{
    outline: none;
}
#login #form > form > button
{
    width: 100%;
    height: 4rem;
    border: none;
    border-radius: 5px;
    background: #000000;
    color: #ffffff;
    font-size: 1.5rem;
    font-weight: bold;
    cursor: pointer;
    transition: 0.3s;
}
#login #form > form > button:hover
{
    transform: scale(1.1);
}
#form > p
{
    font-size: 1.2rem;
    color: #000000;
    text-shadow: none;
    margin-top: 1rem;
}
#form > p > a
{
    color: #461e61;
    text-decoration: underline;
    cursor: pointer;
}

.goHome
{
    cursor: pointer;
    color: #758edf !important;
    align-self: flex-end;
    margin-top: 1rem;
    margin-right: 1rem;
    font-weight: bold;
}

@media only screen and (max-width : 420px) and (orientation: portrait) {
    #login #form
    {
        width: 100%;
    }
    #login #form > form
    {
        margin-top: 1rem;
    }
    #login #form h1
    {
        margin-top: 4rem;
    }
}
@media only screen and (max-width : 900px) and (orientation: landscape) {
    #login #form
    {
        width: 70%;
    }
    #login #form > form
    {
        margin-top: 1rem;
    }
    #login #form h1
    {
        margin-top: 4rem;
    }
    #login {
    background-size: 100% auto;
    height: auto;
    width: 100%;
    }
}
@media (min-width: 768px) and (max-device-width: 1024px) and (orientation: portrait) {
    #login #form
    {
        width: 70%;
    }
    #login {
    background-size: cover;
    background-position: left 45% bottom;
    }
}
@media (width: 1024px) and (orientation: landscape) {
    #login #form
    {
        width: 50%;
    }
    #login #form > form
    {
        margin-top: 1rem;
    }
    #login #form h1
    {
        margin-top: 4rem;
    }
}
</style>